<?php

namespace Drupal\sso_connector\Services;

/**
 * Interface for UserSyncService.
 *
 * Provides an interface for a service that synchronizes user data between
 * systems.
 */
interface UserSyncServiceInterface {

  /**
   * Synchronizes user data with Drupal user entities.
   *
   * Updates existing user entities with the provided data or creates a new one
   * if no matching user is found. Fields managed by Drupal are excluded from
   * the synchronization process.
   *
   * @param array $userData
   *   An associative array of user data to synchronize. Expected keys are
   *   'email' and 'username', with additional keys for any other user fields.
   *
   * @throws \Drupal\Core\Entity\EntityStorageException
   *   Thrown if the user entity cannot be saved.
   */
  public function synchronizeUser(array $userData);

}
